=== debian/changelog ===
ros-indigo-uwsim-osgocean (1.0.3-8trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Mario Prats <marioprats@gmail.com>  Thu, 05 Feb 2015 11:26:15 -0000
